package com.ruoyi.system.service;

import com.ruoyi.common.core.domain.entity.CategoryInfo;
import com.ruoyi.common.core.domain.entity.MusicInfo;
import com.ruoyi.common.core.domain.entity.MusicMaxReq;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;

/**
 * 音乐信息Service接口
 * 
 * @author ruoyi
 * @date 2025-07-15
 */
public interface IMusicInfoService 
{
    /**
     * 查询音乐信息
     * 
     * @param id 音乐信息主键
     * @return 音乐信息
     */
    public MusicInfo selectMusicInfoById(String id);

    /**
     * 查询音乐信息列表
     * 
     * @param musicInfo 音乐信息
     * @return 音乐信息集合
     */
    public List<MusicInfo> selectMusicInfoList(MusicInfo musicInfo);

    /**
     * 新增音乐信息
     * 
     * @param musicInfo 音乐信息
     * @return 结果
     */
    public int insertMusicInfo(MusicInfo musicInfo);

    /**
     * 修改音乐信息
     * 
     * @param musicInfo 音乐信息
     * @return 结果
     */
    public int updateMusicInfo(MusicInfo musicInfo);

    /**
     * 批量删除音乐信息
     * 
     * @param ids 需要删除的音乐信息主键集合
     * @return 结果
     */
    public int deleteMusicInfoByIds(String[] ids);

    /**
     * 删除音乐信息信息
     * 
     * @param id 音乐信息主键
     * @return 结果
     */
    public int deleteMusicInfoById(String id);

    List<MusicInfo> findMusicByCate(CategoryInfo categoryInfo);

    List<MusicInfo> selectMusicInfoByCid(String categoryId);

    List<MusicInfo> findMusicByCollectId(String collectId);

    int addLikeMusic(String musicId);

    List<MusicInfo> findLikeMusicByUser(Long userId);

    int cancelLikeMusic(String musicId);

    int addHistoryMusic(String musicId);

    List<MusicInfo> findHistoryMusicByUser(Long userId);

   MusicInfo getMusicInfo(Long userId, String musicId);

    MusicInfo addMixMusicInfo(MusicMaxReq param);

    MusicInfo editMixMusicInfo(MusicMaxReq param);

    List<MusicInfo> selectMusicInfoByReId(String reId);
}
